JsonCpp - JSON data format manipulation library

JsonCpp project page | JsonCpp home page

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Friends | List of all members
Json::Value Class Reference

Represents a JSON value. More...

`#include <json/value.h>`

Collaboration diagram for Json::Value:

## Public Types
typedef std::vector< std::string > | Members
typedef ValueIterator | iterator
typedef ValueConstIterator | const_iterator
typedef Json::UInt | UInt
typedef Json::Int | Int
typedef Json::UInt64 | UInt64
typedef Json::Int64 | Int64
typedef Json::LargestInt | LargestInt
typedef Json::LargestUInt | LargestUInt
typedef Json::ArrayIndex | ArrayIndex

## Public Member Functions
| Value (ValueType type=nullValue)
| Create a default Value of the given type. More...
| Value (Int value)
| Value (UInt value)
| Value (Int64 value)
| Value (UInt64 value)
| Value (double value)
| Value (const char *value)
| Copy til first 0. (NULL causes to seg-fault.) More...
| Value (const char *begin, const char *end)
| Copy all, incl zeroes. More...
| Value (const StaticString &value)
| Constructs a value from a static string. More...
| Value (const std::string &value)
| Copy data() til size(). Embedded zeroes too. More...
| Value (bool value)
| Value (const Value &other)
| Deep copy. More...
| ~Value ()
Value & | operator= (Value other)
| Deep copy, then swap(other). More...
void | swap (Value &other)
| Swap everything. More...
void | swapPayload (Value &other)
| Swap values but leave comments and source offsets in place. More...
void | copy (const Value &other)
| copy everything. More...
void | copyPayload (const Value &other)
| copy values but leave comments and source offsets in place. More...
ValueType | type () const
bool | operator< (const Value &other) const
| Compare payload only, not comments etc. More...
bool | operator<= (const Value &other) const
bool | operator>= (const Value &other) const
bool | operator> (const Value &other) const
bool | operator== (const Value &other) const
bool | operator!= (const Value &other) const
int | compare (const Value &other) const
const char * | asCString () const
| Embedded zeroes could cause you trouble! More...
std::string | asString () const
| Embedded zeroes are possible. More...
bool | getString (char const **begin, char const **end) const
| Get raw char* of string-value. More...
Int | asInt () const
UInt | asUInt () const
Int64 | asInt64 () const
UInt64 | asUInt64 () const
LargestInt | asLargestInt () const
LargestUInt | asLargestUInt () const
float | asFloat () const
double | asDouble () const
bool | asBool () const
bool | isNull () const
bool | isBool () const
bool | isInt () const
bool | isInt64 () const
bool | isUInt () const
bool | isUInt64 () const
bool | isIntegral () const
bool | isDouble () const
bool | isNumeric () const
bool | isString () const
bool | isArray () const
bool | isObject () const
bool | isConvertibleTo (ValueType other) const
ArrayIndex | size () const
| Number of values in array or object. More...
bool | empty () const
| Return true if empty array, empty object, or null; otherwise, false. More...
bool | operator! () const
| Return isNull() More...
void | clear ()
| Remove all object members and array elements. More...
void | resize (ArrayIndex size)
| Resize the array to size elements. More...
Value & | operator[] (ArrayIndex index)
| Access an array element (zero based index ). More...
Value & | operator[] (int index)
| Access an array element (zero based index ). More...
const Value & | operator[] (ArrayIndex index) const
| Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.) More...
const Value & | operator[] (int index) const
| Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.) More...
Value | get (ArrayIndex index, const Value &defaultValue) const
| If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue. More...
bool | isValidIndex (ArrayIndex index) const
| Return true if index < size(). More...
Value & | append (const Value &value)
| Append value to array at the end. More...
Value & | operator[] (const char *key)
| Access an object value by name, create a null member if it does not exist. More...
const Value & | operator[] (const char *key) const
| Access an object value by name, returns null if there is no member with that name. More...
Value & | operator[] (const std::string &key)
| Access an object value by name, create a null member if it does not exist. More...
const Value & | operator[] (const std::string &key) const
| Access an object value by name, returns null if there is no member with that name. More...
Value & | operator[] (const StaticString &key)
| Access an object value by name, create a null member if it does not exist. More...
Value | get (const char *key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise. More...
Value | get (const char *begin, const char *end, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise. More...
Value | get (const std::string &key, const Value &defaultValue) const
| Return the member named key if it exist, defaultValue otherwise. More...
Value const * | find (char const *begin, char const *end) const
| Most general and efficient version of isMember()const, get()const, and operator[]const. More...
Value const * | demand (char const *begin, char const *end)
| Most general and efficient version of object-mutators. More...
Value | removeMember (const char *key)
| Remove and return the named member. More...
Value | removeMember (const std::string &key)
| Same as removeMember(const char*) More...
bool | removeMember (const char *key, Value *removed)
| Same as removeMember(const char* begin, const char* end, Value* removed), but 'key' is null-terminated. More...
bool | removeMember (std::string const &key, Value *removed)
| Remove the named map member. More...
bool | removeMember (const char *begin, const char *end, Value *removed)
| Same as removeMember(JSONCPP_STRING const& key, Value* removed) More...
bool | removeIndex (ArrayIndex i, Value *removed)
| Remove the indexed array element. More...
bool | isMember (const char *key) const
| Return true if the object has a member named key. More...
bool | isMember (const std::string &key) const
| Return true if the object has a member named key. More...
bool | isMember (const char *begin, const char *end) const
| Same as isMember(JSONCPP_STRING const& key)const. More...
Members | getMemberNames () const
| Return a list of the member names. More...
void | setComment (const char *comment, CommentPlacement placement)
void | setComment (const char *comment, size_t len, CommentPlacement placement)
| Comments must be //... or /* ... */. More...
void | setComment (const std::string &comment, CommentPlacement placement)
| Comments must be //... or /* ... */. More...
bool | hasComment (CommentPlacement placement) const
std::string | getComment (CommentPlacement placement) const
| Include delimiters and embedded newlines. More...
std::string | toStyledString () const
const_iterator | begin () const
const_iterator | end () const
iterator | begin ()
iterator | end ()
void | setOffsetStart (ptrdiff_t start)
void | setOffsetLimit (ptrdiff_t limit)
ptrdiff_t | getOffsetStart () const
ptrdiff_t | getOffsetLimit () const

## Static Public Member Functions
static Value const & | nullSingleton ()
| Prefer this to null or nullRef. More...

## Static Public Attributes
static const Value & | null = Value::nullSingleton()
| We regret this reference to a global instance; prefer the simpler Value(). More...
static const Value & | nullRef = Value::nullSingleton()
| just a kludge for binary-compatibility; same as null More...
static const LargestInt | minLargestInt = LargestInt(~(LargestUInt(-1) / 2))
| Minimum signed integer value that can be stored in a Json::Value. More...
static const LargestInt | maxLargestInt = LargestInt(LargestUInt(-1) / 2)
| Maximum signed integer value that can be stored in a Json::Value. More...
static const LargestUInt | maxLargestUInt = LargestUInt(-1)
| Maximum unsigned integer value that can be stored in a Json::Value. More...
static const Int | minInt = Int(~(UInt(-1) / 2))
| Minimum signed int value that can be stored in a Json::Value. More...
static const Int | maxInt = Int(UInt(-1) / 2)
| Maximum signed int value that can be stored in a Json::Value. More...
static const UInt | maxUInt = UInt(-1)
| Maximum unsigned int value that can be stored in a Json::Value. More...
static const Int64 | minInt64 = Int64(~(UInt64(-1) / 2))
| Minimum signed 64 bits int value that can be stored in a Json::Value. More...
static const Int64 | maxInt64 = Int64(UInt64(-1) / 2)
| Maximum signed 64 bits int value that can be stored in a Json::Value. More...
static const UInt64 | maxUInt64 = UInt64(-1)
| Maximum unsigned 64 bits int value that can be stored in a Json::Value. More...

## Friends
class | ValueIteratorBase

## Detailed Description

Represents a JSON value.

This class is a discriminated union wrapper that can represents a:

- signed integer [range: Value::minInt - Value::maxInt]
- unsigned integer (range: 0 - Value::maxUInt)
- double
- UTF-8 string
- boolean
- 'null'
- an ordered list of Value
- collection of name/value pairs (javascript object)

The type of the held value is represented by a ValueType and can be obtained using type().

Values of an objectValue or arrayValue can be accessed using operator[]() methods. Non-const methods will automatically create the a nullValue element if it does not exist. The sequence of an arrayValue will be automatically resized and initialized with nullValue. resize() can be used to enlarge or truncate an arrayValue.

The get() methods can be used to obtain default value in the case the required element does not exist.

It is possible to iterate over the list of a objectValue values using the getMemberNames() method.

Note
  Value string-length fit in size_t, but keys must be < 2^30. (The reason is an implementation detail.) A #CharReader will raise an exception if a bound is exceeded to avoid security holes in your app, but the Value API does not check bounds. That is the responsibility of the caller.

Definition at line 177 of file value.h.

## Member Typedef Documentation

## ◆ ArrayIndex

typedef Json::ArrayIndex Json::Value::ArrayIndex

Definition at line 191 of file value.h.

## ◆ const_iterator

typedef ValueConstIterator Json::Value::const_iterator

Definition at line 182 of file value.h.

## ◆ Int

typedef Json::Int Json::Value::Int

Definition at line 184 of file value.h.

## ◆ Int64

typedef Json::Int64 Json::Value::Int64

Definition at line 187 of file value.h.

## ◆ iterator

typedef ValueIterator Json::Value::iterator

Definition at line 181 of file value.h.

## ◆ LargestInt

typedef Json::LargestInt Json::Value::LargestInt

Definition at line 189 of file value.h.

## ◆ LargestUInt

typedef Json::LargestUInt Json::Value::LargestUInt

Definition at line 190 of file value.h.

## ◆ Members

typedef std::vector< std::string > Json::Value::Members

Definition at line 180 of file value.h.

## ◆ UInt

typedef Json::UInt Json::Value::UInt

Definition at line 183 of file value.h.

## ◆ UInt64

typedef Json::UInt64 Json::Value::UInt64

Definition at line 186 of file value.h.

## Constructor & Destructor Documentation

## ◆ Value() [1/12]

Json::Value::Value | ( | ValueType | vtype = `nullValue` | ) |

Create a default Value of the given type.

This is a very useful constructor. To create an empty array, pass arrayValue. To create an empty object, pass objectValue. Another Value can then be set to this one by assignment. This is useful since clear() and resize() will not alter types.

    Examples:

Json::Value null_value; // null
Json::Value arr_value(Json::arrayValue); // []
Json::Value obj_value(Json::objectValue); // {}

Default constructor initialization must be equivalent to: memset( this, 0, sizeof(Value) ) This optimization is used in ValueInternalMap fast allocator.

Definition at line 355 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

Referenced by operator[](), resize(), and Value().

Here is the caller graph for this function:

## ◆ Value() [2/12]

Json::Value::Value | ( | Int | value | ) |

Definition at line 384 of file json_value.cpp.

References Json::intValue.

## ◆ Value() [3/12]

Json::Value::Value | ( | UInt | value | ) |

Definition at line 389 of file json_value.cpp.

References Json::uintValue.

## ◆ Value() [4/12]

Json::Value::Value | ( | Int64 | value | ) |

Definition at line 394 of file json_value.cpp.

References Json::intValue.

## ◆ Value() [5/12]

Json::Value::Value | ( | UInt64 | value | ) |

Definition at line 398 of file json_value.cpp.

References Json::uintValue.

## ◆ Value() [6/12]

Json::Value::Value | ( | double | value | ) |

Definition at line 404 of file json_value.cpp.

References Json::realValue.

## ◆ Value() [7/12]

Json::Value::Value | ( | const char * | value | ) |

Copy til first 0. (NULL causes to seg-fault.)

Definition at line 409 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), JSON_ASSERT_MESSAGE, and Json::stringValue.

## ◆ Value() [8/12]

Json::Value::Value | ( | const char * | begin,
|  | const char * | end
| ) |  |

Copy all, incl zeroes.

Definition at line 415 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), and Json::stringValue.

## ◆ Value() [9/12]

Json::Value::Value | ( | const StaticString & | value | ) |

Constructs a value from a static string.

Like other value string constructor but do not duplicate the string for internal storage. The given string must remain alive after the call to this constructor.

Note
  This works only for null-terminated strings. (We cannot change the size of this class, so we have nowhere to store the length, which might be computed later for various operations.)

Example of usage:

static StaticString foo("some text");
Json::Value aValue(foo);

Definition at line 427 of file json_value.cpp.

References Json::StaticString::c_str(), Json::duplicateAndPrefixStringValue(), Json::stringValue, and Value().

## ◆ Value() [10/12]

Json::Value::Value | ( | const std::string & | value | ) |

Copy data() til size(). Embedded zeroes too.

Definition at line 421 of file json_value.cpp.

References Json::duplicateAndPrefixStringValue(), and Json::stringValue.

## ◆ Value() [11/12]

Json::Value::Value | ( | bool | value | ) |

Definition at line 439 of file json_value.cpp.

References Json::booleanValue.

## ◆ Value() [12/12]

Json::Value::Value | ( | const Value & | other | ) |

Deep copy.

Definition at line 444 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::duplicateAndPrefixStringValue(), Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::numberOfCommentPlacement, Json::objectValue, Json::realValue, Json::stringValue, swap(), Json::uintValue, and Value().

## ◆ ~Value()

Json::Value::~Value | ( |  | ) |

Definition at line 496 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::releasePrefixedStringValue(), Json::stringValue, and Json::uintValue.

## Member Function Documentation

## ◆ append()

Value & Json::Value::append | ( | const Value & | value | ) |

Append value to array at the end.

Equivalent to jsonvalue[jsonvalue.size()] = value;

Definition at line 1148 of file json_value.cpp.

References size().

## ◆ asBool()

bool Json::Value::asBool | ( |  | ) | const

Definition at line 882 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by Json::FastWriter::write(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ asCString()

const char * Json::Value::asCString | ( |  | ) | const

Embedded zeroes could cause you trouble!

Definition at line 666 of file json_value.cpp.

References Json::decodePrefixedString(), JSON_ASSERT_MESSAGE, and Json::stringValue.

Referenced by Json::Reader::parse().

Here is the caller graph for this function:

## ◆ asDouble()

double Json::Value::asDouble | ( |  | ) | const

Definition at line 837 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by isConvertibleTo(), Json::FastWriter::write(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ asFloat()

float Json::Value::asFloat | ( |  | ) | const

Definition at line 859 of file json_value.cpp.

References Json::booleanValue, Json::intValue, JSON_FAIL_MESSAGE, Json::nullValue, Json::realValue, and Json::uintValue.

## ◆ asInt()

Value::Int Json::Value::asInt | ( |  | ) | const

Definition at line 732 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, isInt(), JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, maxInt, minInt, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by asLargestInt().

Here is the caller graph for this function:

## ◆ asInt64()

Value::Int64 Json::Value::asInt64 | ( |  | ) | const

Definition at line 778 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, isInt64(), JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, maxInt64, minInt64, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by asLargestInt().

Here is the caller graph for this function:

## ◆ asLargestInt()

LargestInt Json::Value::asLargestInt | ( |  | ) | const

Definition at line 821 of file json_value.cpp.

References asInt(), and asInt64().

Referenced by Json::FastWriter::write(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ asLargestUInt()

LargestUInt Json::Value::asLargestUInt | ( |  | ) | const

Definition at line 829 of file json_value.cpp.

References asUInt(), and asUInt64().

Referenced by Json::FastWriter::write(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ asString()

std::string Json::Value::asString | ( |  | ) | const

Embedded zeroes are possible.

Definition at line 697 of file json_value.cpp.

References Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_FAIL_MESSAGE, JSONCPP_STRING, Json::nullValue, Json::realValue, Json::stringValue, Json::uintValue, and Json::valueToString().

Referenced by Json::Reader::good(), and isConvertibleTo().

Here is the caller graph for this function:

## ◆ asUInt()

Value::UInt Json::Value::asUInt | ( |  | ) | const

Definition at line 754 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, isUInt(), JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, maxUInt, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by asLargestUInt().

Here is the caller graph for this function:

## ◆ asUInt64()

Value::UInt64 Json::Value::asUInt64 | ( |  | ) | const

Definition at line 799 of file json_value.cpp.

References Json::booleanValue, Json::InRange(), Json::intValue, isUInt64(), JSON_ASSERT_MESSAGE, JSON_FAIL_MESSAGE, maxUInt64, Json::nullValue, Json::realValue, and Json::uintValue.

Referenced by asLargestUInt().

Here is the caller graph for this function:

## ◆ begin() [1/2]

Value::const_iterator Json::Value::begin | ( |  | ) | const

Definition at line 1465 of file json_value.cpp.

References Json::arrayValue, and Json::objectValue.

## ◆ begin() [2/2]

Value::iterator Json::Value::begin | ( |  | ) |

Definition at line 1491 of file json_value.cpp.

References Json::arrayValue, and Json::objectValue.

## ◆ clear()

void Json::Value::clear | ( |  | ) |

Remove all object members and array elements.

Precondition
  type() is arrayValue, objectValue, or nullValue

Postcondition
  type() is unchanged

Definition at line 967 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

Referenced by resize().

Here is the caller graph for this function:

## ◆ compare()

int Json::Value::compare | ( | const Value & | other | ) | const

Definition at line 558 of file json_value.cpp.

## ◆ copy()

void Json::Value::copy | ( | const Value & | other | ) |

copy everything.

Definition at line 549 of file json_value.cpp.

References copyPayload().

## ◆ copyPayload()

void Json::Value::copyPayload | ( | const Value & | other | ) |

copy values but leave comments and source offsets in place.

Definition at line 536 of file json_value.cpp.

Referenced by copy().

Here is the caller graph for this function:

## ◆ demand()

Value const* Json::Value::demand | ( | char const * | begin,
|  | char const * | end
| ) |  |

Most general and efficient version of object-mutators.

Note
  As stated elsewhere, behavior is undefined if (end-begin) >= 2^30

Returns
  non-zero, but JSON_ASSERT if this is neither object nor nullValue.

## ◆ empty()

bool Json::Value::empty | ( |  | ) | const

Return true if empty array, empty object, or null; otherwise, false.

Definition at line 958 of file json_value.cpp.

References isArray(), isNull(), isObject(), and size().

## ◆ end() [1/2]

Value::const_iterator Json::Value::end | ( |  | ) | const

Definition at line 1478 of file json_value.cpp.

References Json::arrayValue, and Json::objectValue.

## ◆ end() [2/2]

Value::iterator Json::Value::end | ( |  | ) |

Definition at line 1504 of file json_value.cpp.

References Json::arrayValue, and Json::objectValue.

## ◆ find()

Value const * Json::Value::find | ( | char const * | begin,
|  | char const * | end
| ) |  | const

Most general and efficient version of isMember()const, get()const, and operator[]const.

Note
  As stated elsewhere, behavior is undefined if (end-begin) >= 2^30

Definition at line 1100 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, Json::nullValue, and Json::objectValue.

Referenced by get(), isMember(), and operator[]().

Here is the caller graph for this function:

## ◆ get() [1/4]

Value Json::Value::get | ( | ArrayIndex | index,
|  | const Value & | defaultValue
| ) |  | const

If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue.

Definition at line 1093 of file json_value.cpp.

References nullSingleton().

Referenced by removeIndex().

Here is the caller graph for this function:

## ◆ get() [2/4]

Value Json::Value::get | ( | const char * | key,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Definition at line 1159 of file json_value.cpp.

## ◆ get() [3/4]

Value Json::Value::get | ( | const char * | begin,
|  | const char * | end,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy
  key may contain embedded nulls.

Definition at line 1154 of file json_value.cpp.

References find().

## ◆ get() [4/4]

Value Json::Value::get | ( | const std::string & | key,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Parameters

  key | may contain embedded nulls.

Definition at line 1163 of file json_value.cpp.

## ◆ getComment()

std::string Json::Value::getComment | ( | CommentPlacement | placement | ) | const

Include delimiters and embedded newlines.

Definition at line 1441 of file json_value.cpp.

References hasComment().

Referenced by Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ getMemberNames()

Value::Members Json::Value::getMemberNames | ( |  | ) | const

Return a list of the member names.

If null, return an empty list.

Precondition
  type() is objectValue or nullValue

Postcondition
  if type() was nullValue, it remains nullValue

Definition at line 1256 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, JSONCPP_STRING, Json::nullValue, and Json::objectValue.

Referenced by Json::FastWriter::write(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ getOffsetLimit()

ptrdiff_t Json::Value::getOffsetLimit | ( |  | ) | const

Definition at line 1453 of file json_value.cpp.

Referenced by Json::Reader::good(), and Json::Reader::pushError().

Here is the caller graph for this function:

## ◆ getOffsetStart()

ptrdiff_t Json::Value::getOffsetStart | ( |  | ) | const

Definition at line 1451 of file json_value.cpp.

Referenced by Json::Reader::good(), and Json::Reader::pushError().

Here is the caller graph for this function:

## ◆ getString()

bool Json::Value::getString | ( | char const ** | begin,
|  | char const ** | end
| ) |  | const

Get raw char* of string-value.

Returns
  false if !string. (Seg-fault if str or end are NULL.)

Definition at line 688 of file json_value.cpp.

References Json::decodePrefixedString(), and Json::stringValue.

Referenced by Json::FastWriter::write(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ hasComment()

bool Json::Value::hasComment | ( | CommentPlacement | placement | ) | const

Definition at line 1437 of file json_value.cpp.

Referenced by getComment(), toStyledString(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ isArray()

bool Json::Value::isArray | ( |  | ) | const

Definition at line 1415 of file json_value.cpp.

References Json::arrayValue.

Referenced by empty(), Json::Reader::good(), Json::Path::make(), Json::Reader::parse(), Json::Path::resolve(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ isBool()

bool Json::Value::isBool | ( |  | ) | const

Definition at line 1305 of file json_value.cpp.

References Json::booleanValue.

## ◆ isConvertibleTo()

bool Json::Value::isConvertibleTo | ( | ValueType | other | ) | const

Definition at line 901 of file json_value.cpp.

References Json::arrayValue, asDouble(), asString(), Json::booleanValue, Json::InRange(), Json::intValue, isInt(), isNumeric(), isUInt(), JSON_ASSERT_UNREACHABLE, maxInt, maxUInt, minInt, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ isDouble()

bool Json::Value::isDouble | ( |  | ) | const

Definition at line 1409 of file json_value.cpp.

References Json::intValue, Json::realValue, and Json::uintValue.

Referenced by isNumeric().

Here is the caller graph for this function:

## ◆ isInt()

bool Json::Value::isInt | ( |  | ) | const

Definition at line 1307 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), maxInt, minInt, Json::realValue, and Json::uintValue.

Referenced by asInt(), and isConvertibleTo().

Here is the caller graph for this function:

## ◆ isInt64()

bool Json::Value::isInt64 | ( |  | ) | const

Definition at line 1349 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), maxInt64, minInt64, Json::realValue, and Json::uintValue.

Referenced by asInt64().

Here is the caller graph for this function:

## ◆ isIntegral()

bool Json::Value::isIntegral | ( |  | ) | const

Definition at line 1389 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), maxUInt, minInt, minInt64, Json::realValue, and Json::uintValue.

## ◆ isMember() [1/3]

bool Json::Value::isMember | ( | const char * | key | ) | const

Return true if the object has a member named key.

Note
  'key' must be null-terminated.

Definition at line 1241 of file json_value.cpp.

Referenced by isMember().

Here is the caller graph for this function:

## ◆ isMember() [2/3]

bool Json::Value::isMember | ( | const std::string & | key | ) | const

Return true if the object has a member named key.

Parameters

  key | may contain embedded nulls.

Definition at line 1245 of file json_value.cpp.

References isMember().

## ◆ isMember() [3/3]

bool Json::Value::isMember | ( | const char * | begin,
|  | const char * | end
| ) |  | const

Same as isMember(JSONCPP_STRING const& key)const.

Definition at line 1236 of file json_value.cpp.

References find().

## ◆ isNull()

bool Json::Value::isNull | ( |  | ) | const

Definition at line 1303 of file json_value.cpp.

References Json::nullValue.

Referenced by empty(), and operator!().

Here is the caller graph for this function:

## ◆ isNumeric()

bool Json::Value::isNumeric | ( |  | ) | const

Definition at line 1411 of file json_value.cpp.

References isDouble().

Referenced by isConvertibleTo().

Here is the caller graph for this function:

## ◆ isObject()

bool Json::Value::isObject | ( |  | ) | const

Definition at line 1417 of file json_value.cpp.

References Json::objectValue.

Referenced by empty(), Json::Reader::good(), Json::Path::make(), Json::Reader::parse(), Json::Path::resolve(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ isString()

bool Json::Value::isString | ( |  | ) | const

Definition at line 1413 of file json_value.cpp.

References Json::stringValue.

## ◆ isUInt()

bool Json::Value::isUInt | ( |  | ) | const

Definition at line 1326 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), maxUInt, Json::realValue, and Json::uintValue.

Referenced by asUInt(), and isConvertibleTo().

Here is the caller graph for this function:

## ◆ isUInt64()

bool Json::Value::isUInt64 | ( |  | ) | const

Definition at line 1369 of file json_value.cpp.

References Json::intValue, Json::IsIntegral(), Json::realValue, and Json::uintValue.

Referenced by asUInt64().

Here is the caller graph for this function:

## ◆ isValidIndex()

bool Json::Value::isValidIndex | ( | ArrayIndex | index | ) | const

Return true if index < size().

Definition at line 1098 of file json_value.cpp.

References size().

Referenced by Json::Path::resolve().

Here is the caller graph for this function:

## ◆ nullSingleton()

Value const & Json::Value::nullSingleton | ( |  | ) |
| static

Prefer this to null or nullRef.

Definition at line 40 of file json_value.cpp.

References maxInt, maxInt64, maxUInt, maxUInt64, minInt, minInt64, null, and nullRef.

Referenced by get(), operator[](), removeMember(), and Json::Path::resolve().

Here is the caller graph for this function:

## ◆ operator!()

bool Json::Value::operator! | ( |  | ) | const

Return isNull()

Definition at line 965 of file json_value.cpp.

References isNull().

## ◆ operator!=()

bool Json::Value::operator!= | ( | const Value & | other | ) | const

Definition at line 664 of file json_value.cpp.

## ◆ operator<()

bool Json::Value::operator< | ( | const Value & | other | ) | const

Compare payload only, not comments etc.

Definition at line 566 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_ASSERT, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ operator<=()

bool Json::Value::operator<= | ( | const Value & | other | ) | const

Definition at line 613 of file json_value.cpp.

## ◆ operator=()

Value & Json::Value::operator= | ( | Value | other | ) |

Deep copy, then swap(other).

Note
  Over-write existing comments. To preserve comments, use swapPayload().

Definition at line 521 of file json_value.cpp.

References swap().

## ◆ operator==()

bool Json::Value::operator== | ( | const Value & | other | ) | const

Definition at line 619 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::decodePrefixedString(), Json::intValue, JSON_ASSERT, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

## ◆ operator>()

bool Json::Value::operator> | ( | const Value & | other | ) | const

Definition at line 617 of file json_value.cpp.

## ◆ operator>=()

bool Json::Value::operator>= | ( | const Value & | other | ) | const

Definition at line 615 of file json_value.cpp.

## ◆ operator[]() [1/9]

Value & Json::Value::operator[] | ( | ArrayIndex | index | ) |

Access an array element (zero based index ).

If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 1001 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, nullSingleton(), Json::nullValue, and Value().

Referenced by operator[]().

Here is the caller graph for this function:

## ◆ operator[]() [2/9]

Value & Json::Value::operator[] | ( | int | index | ) |

Access an array element (zero based index ).

If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 1017 of file json_value.cpp.

References JSON_ASSERT_MESSAGE.

## ◆ operator[]() [3/9]

const Value & Json::Value::operator[] | ( | ArrayIndex | index | ) | const

Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 1024 of file json_value.cpp.

References Json::arrayValue, JSON_ASSERT_MESSAGE, nullSingleton(), and Json::nullValue.

## ◆ operator[]() [4/9]

const Value & Json::Value::operator[] | ( | int | index | ) | const

Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

Definition at line 1037 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, nullSingleton(), Json::nullValue, Json::objectValue, and Value().

## ◆ operator[]() [5/9]

Value & Json::Value::operator[] | ( | const char * | key | ) |

Access an object value by name, create a null member if it does not exist.

Note
  Because of our implementation, keys are limited to 2^30 -1 chars. Exceeding that will cause an exception.

Definition at line 1124 of file json_value.cpp.

## ◆ operator[]() [6/9]

const Value & Json::Value::operator[] | ( | const char * | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Definition at line 1111 of file json_value.cpp.

References find(), and nullSingleton().

## ◆ operator[]() [7/9]

Value & Json::Value::operator[] | ( | const std::string & | key | ) |

Access an object value by name, create a null member if it does not exist.

Parameters

  key | may contain embedded nulls.

Definition at line 1128 of file json_value.cpp.

## ◆ operator[]() [8/9]

Value const & Json::Value::operator[] | ( | const std::string & | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Parameters

  key | may contain embedded nulls.

Definition at line 1117 of file json_value.cpp.

References find(), and nullSingleton().

## ◆ operator[]() [9/9]

Value & Json::Value::operator[] | ( | const StaticString & | key | ) |

Access an object value by name, create a null member if it does not exist.

If the object has no entry for that name, then the member name used to store the new entry is not duplicated. Example of use:

Json::Value object;
static const StaticString code("code");
object[code] = 1234;

Definition at line 1132 of file json_value.cpp.

References Json::StaticString::c_str(), find(), nullSingleton(), and operator[]().

## ◆ removeIndex()

bool Json::Value::removeIndex | ( | ArrayIndex | i,
|  | Value * | removed
| ) |  |

Remove the indexed array element.

O(n) expensive operations. Update 'removed' iff removed.

Returns
  true iff removed (no exceptions)

Definition at line 1206 of file json_value.cpp.

References Json::arrayValue, get(), and size().

## ◆ removeMember() [1/5]

Value Json::Value::removeMember | ( | const char * | key | ) |

Remove and return the named member.

Do nothing if it did not exist.

Returns
  the removed Value, or null.

Precondition
  type() is objectValue or nullValue

Postcondition
  type() is unchanged

Deprecated:

Definition at line 1190 of file json_value.cpp.

References JSON_ASSERT_MESSAGE, nullSingleton(), Json::nullValue, and Json::objectValue.

Referenced by removeMember().

Here is the caller graph for this function:

## ◆ removeMember() [2/5]

Value Json::Value::removeMember | ( | const std::string & | key | ) |

Same as removeMember(const char*)

Parameters

  key | may contain embedded nulls.

Deprecated:

Definition at line 1201 of file json_value.cpp.

References removeMember().

## ◆ removeMember() [3/5]

bool Json::Value::removeMember | ( | const char * | key,
|  | Value * | removed
| ) |  |

Same as removeMember(const char* begin, const char* end, Value* removed), but 'key' is null-terminated.

Definition at line 1182 of file json_value.cpp.

References removeMember().

## ◆ removeMember() [4/5]

bool Json::Value::removeMember | ( | std::string const & | key,
|  | Value * | removed
| ) |  |

Remove the named map member.

Update 'removed' iff removed.

Parameters

  key | may contain embedded nulls.

Returns
  true iff removed (no exceptions)

Definition at line 1186 of file json_value.cpp.

References removeMember().

## ◆ removeMember() [5/5]

bool Json::Value::removeMember | ( | const char * | begin,
|  | const char * | end,
|  | Value * | removed
| ) |  |

Same as removeMember(JSONCPP_STRING const& key, Value* removed)

Definition at line 1169 of file json_value.cpp.

References Json::objectValue.

## ◆ resize()

void Json::Value::resize | ( | ArrayIndex | size | ) |

Resize the array to size elements.

New elements are initialized to null. May only be called on nullValue or arrayValue.

Precondition
  type() is arrayValue or nullValue

Postcondition
  type() is arrayValue

Definition at line 983 of file json_value.cpp.

References Json::arrayValue, clear(), JSON_ASSERT, JSON_ASSERT_MESSAGE, Json::nullValue, size(), and Value().

## ◆ setComment() [1/3]

void Json::Value::setComment | ( | const char * | comment,
|  | CommentPlacement | placement
| ) |  |

Deprecated:
  Always pass len.

Definition at line 1429 of file json_value.cpp.

Referenced by Json::Reader::good(), Json::Reader::parse(), and setComment().

Here is the caller graph for this function:

## ◆ setComment() [2/3]

void Json::Value::setComment | ( | const char * | comment,
|  | size_t | len,
|  | CommentPlacement | placement
| ) |  |

Comments must be //... or /* ... */.

Definition at line 1419 of file json_value.cpp.

References Json::numberOfCommentPlacement.

## ◆ setComment() [3/3]

void Json::Value::setComment | ( | const std::string & | comment,
|  | CommentPlacement | placement
| ) |  |

Comments must be //... or /* ... */.

Definition at line 1433 of file json_value.cpp.

References setComment().

## ◆ setOffsetLimit()

void Json::Value::setOffsetLimit | ( | ptrdiff_t | limit | ) |

Definition at line 1449 of file json_value.cpp.

Referenced by Json::Reader::parse().

Here is the caller graph for this function:

## ◆ setOffsetStart()

void Json::Value::setOffsetStart | ( | ptrdiff_t | start | ) |

Definition at line 1447 of file json_value.cpp.

Referenced by Json::Reader::parse().

Here is the caller graph for this function:

## ◆ size()

ArrayIndex Json::Value::size | ( |  | ) | const

Number of values in array or object.

Definition at line 935 of file json_value.cpp.

References Json::arrayValue, Json::booleanValue, Json::intValue, JSON_ASSERT_UNREACHABLE, Json::nullValue, Json::objectValue, Json::realValue, Json::stringValue, and Json::uintValue.

Referenced by append(), Json::decodePrefixedString(), empty(), isValidIndex(), removeIndex(), resize(), Json::StreamWriterBuilder::validate(), Json::CharReaderBuilder::validate(), Json::FastWriter::write(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## ◆ swap()

void Json::Value::swap | ( | Value & | other | ) |

Swap everything.

Definition at line 542 of file json_value.cpp.

References swapPayload().

Referenced by operator=(), std::swap(), and Value().

Here is the caller graph for this function:

## ◆ swapPayload()

void Json::Value::swapPayload | ( | Value & | other | ) |

Swap values but leave comments and source offsets in place.

Definition at line 526 of file json_value.cpp.

Referenced by Json::Reader::good(), Json::Reader::parse(), and swap().

Here is the caller graph for this function:

## ◆ toStyledString()

std::string Json::Value::toStyledString | ( |  | ) | const

Definition at line 1455 of file json_value.cpp.

References Json::commentBefore, hasComment(), JSONCPP_STRING, and Json::writeString().

## ◆ type()

ValueType Json::Value::type | ( |  | ) | const

Definition at line 556 of file json_value.cpp.

Referenced by Json::FastWriter::write(), Json::StyledWriter::write(), and Json::StyledStreamWriter::write().

Here is the caller graph for this function:

## Friends And Related Function Documentation

## ◆ ValueIteratorBase

friend class ValueIteratorBase
| friend

Definition at line 178 of file value.h.

## Member Data Documentation

## ◆ maxInt

const Int Json::Value::maxInt = Int(UInt(-1) / 2)
| static

Maximum signed int value that can be stored in a Json::Value.

Definition at line 207 of file value.h.

Referenced by asInt(), Json::Reader::good(), isConvertibleTo(), isInt(), nullSingleton(), and Json::Reader::parse().

## ◆ maxInt64

const Int64 Json::Value::maxInt64 = Int64(UInt64(-1) / 2)
| static

Maximum signed 64 bits int value that can be stored in a Json::Value.

Definition at line 215 of file value.h.

Referenced by asInt64(), isInt64(), and nullSingleton().

## ◆ maxLargestInt

const LargestInt Json::Value::maxLargestInt = LargestInt(LargestUInt(-1) / 2)
| static

Maximum signed integer value that can be stored in a Json::Value.

Definition at line 200 of file value.h.

Referenced by Json::Reader::parse(), and Json::valueToString().

## ◆ maxLargestUInt

const LargestUInt Json::Value::maxLargestUInt = LargestUInt(-1)
| static

Maximum unsigned integer value that can be stored in a Json::Value.

Definition at line 202 of file value.h.

Referenced by Json::Reader::good(), and Json::Reader::parse().

## ◆ maxUInt

const UInt Json::Value::maxUInt = UInt(-1)
| static

Maximum unsigned int value that can be stored in a Json::Value.

Definition at line 209 of file value.h.

Referenced by asUInt(), isConvertibleTo(), isIntegral(), isUInt(), and nullSingleton().

## ◆ maxUInt64

const UInt64 Json::Value::maxUInt64 = UInt64(-1)
| static

Maximum unsigned 64 bits int value that can be stored in a Json::Value.

Definition at line 217 of file value.h.

Referenced by asUInt64(), and nullSingleton().

## ◆ minInt

const Int Json::Value::minInt = Int(~(UInt(-1) / 2))
| static

Minimum signed int value that can be stored in a Json::Value.

Definition at line 205 of file value.h.

Referenced by asInt(), isConvertibleTo(), isInt(), isIntegral(), and nullSingleton().

## ◆ minInt64

const Int64 Json::Value::minInt64 = Int64(~(UInt64(-1) / 2))
| static

Minimum signed 64 bits int value that can be stored in a Json::Value.

Definition at line 213 of file value.h.

Referenced by asInt64(), isInt64(), isIntegral(), and nullSingleton().

## ◆ minLargestInt

const LargestInt Json::Value::minLargestInt = LargestInt(~(LargestUInt(-1) / 2))
| static

Minimum signed integer value that can be stored in a Json::Value.

Definition at line 198 of file value.h.

Referenced by Json::Reader::good(), Json::Reader::parse(), and Json::valueToString().

## ◆ null

Value const & Json::Value::null = Value::nullSingleton()
| static

We regret this reference to a global instance; prefer the simpler Value().

Definition at line 193 of file value.h.

Referenced by nullSingleton(), and Json::Path::resolve().

## ◆ nullRef

Value const & Json::Value::nullRef = Value::nullSingleton()
| static

just a kludge for binary-compatibility; same as null

Definition at line 194 of file value.h.

Referenced by nullSingleton().

The documentation for this class was generated from the following files:

- include/json/value.h
- src/lib_json/json_value.cpp